// TestVC0Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestVC0.h"
#include "TestVC0Dlg.h"
#include "Biography.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_edsource;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnCreated();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_edsource = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_EDSOURCE, m_edsource);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_CREATED, OnCreated)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestVC0Dlg dialog

CTestVC0Dlg::CTestVC0Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestVC0Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestVC0Dlg)
	m_book = _T("");
	m_chapter = _T("");
	m_title = _T("");
	m_verse = _T("");
	m_textdata = _T("");
	m_edword = _T("");
	m_staticfound = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pDB = NULL;
    m_pRS = NULL;
	m_pRSW0 = NULL;
}

void CTestVC0Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestVC0Dlg)
	DDX_Control(pDX, IDC_COMBO_TITLE, m_combotitle);
	DDX_Control(pDX, IDC_COMBO_CHAPTER, m_combochapter);
	DDX_Control(pDX, IDC_STATICVERSE, m_staticverse);
	DDX_Control(pDX, IDC_STATICTITLE, m_statictitle);
	DDX_Control(pDX, IDC_STATICSEL, m_staticsel);
	DDX_Control(pDX, IDC_STATICCHAPTER, m_staticchapter);
	DDX_Control(pDX, IDC_STATICBOOK, m_staticbook);
	DDX_Control(pDX, IDC_COMBO_VERSE_RECNO, m_comboverserecno);
	DDX_Control(pDX, IDC_COMBO_VERSE, m_comboverse);
	DDX_Control(pDX, IDC_COMBO_TITLE_RECNO, m_combotitlerecno);
	DDX_Control(pDX, IDC_COMBO_CHAPTER_RECNO, m_combochapterrecno);
	DDX_Control(pDX, IDC_COMBO_BOOK_RECNO, m_combobookrecno);
	DDX_Control(pDX, IDC_COMBO_BOOK, m_combobook);
	DDX_Control(pDX, IDC_STATICTYPE, m_statictype);
	DDX_Control(pDX, IDC_STATICFOUND, m_staticfoundcontrol);
	DDX_Control(pDX, IDC_SEARCHLIST, m_searchlist);
	DDX_Control(pDX, IDC_EDWORD, m_edwordcontrol);
	DDX_Control(pDX, IDC_DISPLAY, m_display);
	DDX_Control(pDX, IDC_TAB1, m_tab1);
	DDX_Text(pDX, IDC_BOOK, m_book);
	DDX_Text(pDX, IDC_CHAPTER, m_chapter);
	DDX_Text(pDX, IDC_TITLE, m_title);
	DDX_Text(pDX, IDC_VERSE, m_verse);
	DDX_Text(pDX, IDC_TEXTDATA, m_textdata);
	DDX_Text(pDX, IDC_EDWORD, m_edword);
	DDX_Text(pDX, IDC_STATICFOUND, m_staticfound);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestVC0Dlg, CDialog)
	//{{AFX_MSG_MAP(CTestVC0Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RECORD_FIRST, OnRecordFirst)
	ON_BN_CLICKED(IDC_RECORD_PREV, OnRecordPrev)
	ON_BN_CLICKED(IDC_RECORD_NEXT, OnRecordNext)
	ON_BN_CLICKED(IDC_RECORD_LAST, OnRecordLast)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	ON_EN_CHANGE(IDC_EDWORD, OnChangeEdword)
	ON_BN_CLICKED(IDC_DISPLAY, OnDisplay)
	ON_NOTIFY(NM_CLICK, IDC_SEARCHLIST, OnClickSearchlist)
	ON_CBN_SELCHANGE(IDC_COMBO_BOOK, OnSelchangeComboBook)
	ON_CBN_SELCHANGE(IDC_COMBO_TITLE, OnSelchangeComboTitle)
	ON_CBN_SELCHANGE(IDC_COMBO_CHAPTER, OnSelchangeComboChapter)
	ON_CBN_SELCHANGE(IDC_COMBO_VERSE, OnSelchangeComboVerse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestVC0Dlg message handlers

BOOL CTestVC0Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		    //Remove the Maximize and Size items
			pSysMenu->RemoveMenu(SC_SIZE, MF_BYCOMMAND);
            pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);
	
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// *** Initialize / declaration ***
	m_pDB = new CDaoDatabase;
	m_pRS = new CDaoRecordset(m_pDB);

	TCHAR curdir[MAX_PATH];  //MAX_PATH - Maximum length of directory
	CString Databasename;

    // Get Current Directory
    GetCurrentDirectory( MAX_PATH, curdir ); 

	//DataBase name, KJV.mdb at Current Directory
	Databasename = (CString)curdir + _T("\\KJV.mdb");
    m_pDB->Open(Databasename);  

    m_pRS->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);   

	//Move to first available record
	m_pRS->Move(2);
	//Display the content of record
	CalculValue();
	//Stiuation of controls
    SetButtons(TRUE);

	//Initialize the Tab Comtrol
	TC_ITEM TabCtrlItem;
	TabCtrlItem.mask = TCIF_TEXT;
	TabCtrlItem.pszText = "           By word           ";
	m_tab1.InsertItem( 0, &TabCtrlItem );
	TabCtrlItem.pszText = "          By address         ";
	m_tab1.InsertItem( 1, &TabCtrlItem );

	//Make these controls visible or invisible, for Tab Control
	m_staticsel.ShowWindow(SW_HIDE);
	m_combobook.ShowWindow(SW_HIDE);
	m_combotitle.ShowWindow(SW_HIDE);
	m_combochapter.ShowWindow(SW_HIDE);
	m_comboverse.ShowWindow(SW_HIDE);
	m_staticbook.ShowWindow(SW_HIDE);
	m_statictitle.ShowWindow(SW_HIDE);
	m_staticchapter.ShowWindow(SW_HIDE);
	m_staticverse.ShowWindow(SW_HIDE);
	
	m_searchlist.ShowWindow(SW_SHOW);
	m_edwordcontrol.ShowWindow(SW_SHOW);
	m_display.ShowWindow(SW_SHOW);
	m_statictype.ShowWindow(SW_SHOW);
	m_staticfoundcontrol.ShowWindow(SW_SHOW);

	//Show the header row of List Control
	int strWidth1 = m_searchlist.GetStringWidth(_T("00000"));
	m_searchlist.InsertColumn(1, _T("Record"), LVCFMT_LEFT,2*strWidth1, 1);
	m_searchlist.InsertColumn(2, _T("Bk"), LVCFMT_LEFT, strWidth1, 1);
	m_searchlist.InsertColumn(3, _T("Title"), LVCFMT_LEFT, 4*strWidth1, 1);
	m_searchlist.InsertColumn(4, _T("Ch"), LVCFMT_LEFT, strWidth1, 1);
    m_searchlist.InsertColumn(5, _T("Verse"), LVCFMT_LEFT, 3*strWidth1/2, 1);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestVC0Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestVC0Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestVC0Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//Display the contents of record
void CTestVC0Dlg::CalculValue()
{
	COleVariant var; 
	var = m_pRS->GetFieldValue(_T("Book"));
	m_book = CString(V_BSTRT(&var));

	var = m_pRS->GetFieldValue(_T("BookTitle"));
	m_title = CString(V_BSTRT(&var)); 

	var = m_pRS->GetFieldValue(_T("Chapter"));
	m_chapter = CString(V_BSTRT(&var));

	var = m_pRS->GetFieldValue(_T("Verse"));
	m_verse = CString(V_BSTRT(&var));

	var = m_pRS->GetFieldValue(_T("TextData"));
	m_textdata = CString(V_BSTRT(&var));

	UpdateData(FALSE);
	return;
}

//To enable or disable navigation controls - SetButtons function
void CTestVC0Dlg::SetButtons(BOOL bVal)
{
	GetDlgItem(IDC_RECORD_FIRST)->EnableWindow(!bVal);
	GetDlgItem(IDC_RECORD_PREV)->EnableWindow(!bVal);
	GetDlgItem(IDC_RECORD_NEXT)->EnableWindow(bVal);
	GetDlgItem(IDC_RECORD_LAST)->EnableWindow(bVal);
}

//To enable or disable navigation controls - SetButtonsAll function
void CTestVC0Dlg::SetButtonsAll(BOOL bVal)
{
	GetDlgItem(IDC_RECORD_FIRST)->EnableWindow(bVal);
	GetDlgItem(IDC_RECORD_PREV)->EnableWindow(bVal);
	GetDlgItem(IDC_RECORD_NEXT)->EnableWindow(bVal);
	GetDlgItem(IDC_RECORD_LAST)->EnableWindow(bVal);
}

void CTestVC0Dlg::OnRecordFirst() 
{
	m_pRS->MoveFirst();
	m_pRS->Move(2);
	CalculValue(); 
	SetButtons(TRUE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnRecordPrev() 
{
	m_pRS->MovePrev();
	CalculValue();

	if (m_pRS->GetRecordCount() > 0 && m_book == "01" && m_chapter == "001" & m_verse == "001")
	{
	SetButtons(TRUE);
	return;
	}
	else
	SetButtonsAll(TRUE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnRecordNext() 
{
	m_pRS->MoveNext();
	CalculValue();

	if (m_pRS->GetRecordCount() > 0 && m_book == "66" && m_chapter == "022" & m_verse == "021")

	{ 
	SetButtons(FALSE);
	return;
	}
	else
	SetButtonsAll(TRUE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnRecordLast() 
{
	m_pRS->MoveLast();
	CalculValue();
	SetButtons(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int ntab = m_tab1.GetCurSel();
	switch(ntab)
	{     
	case 0: //tab label = By word
		{
		  m_staticsel.ShowWindow(SW_HIDE);
		  m_combobook.ShowWindow(SW_HIDE);
          m_combotitle.ShowWindow(SW_HIDE);
          m_combochapter.ShowWindow(SW_HIDE);
          m_comboverse.ShowWindow(SW_HIDE);
		  m_staticbook.ShowWindow(SW_HIDE);
		  m_statictitle.ShowWindow(SW_HIDE);
		  m_staticchapter.ShowWindow(SW_HIDE);
		  m_staticverse.ShowWindow(SW_HIDE);
		  
		  m_searchlist.ShowWindow(SW_SHOW);
		  m_edwordcontrol.ShowWindow(SW_SHOW);
		  m_display.ShowWindow(SW_SHOW);
		  m_statictype.ShowWindow(SW_SHOW);
		  m_staticfoundcontrol.ShowWindow(SW_SHOW);
          
		break;
		}
	case 1: //tab label = By address
		{
	      m_staticsel.ShowWindow(SW_SHOW);
	      m_combobook.ShowWindow(SW_SHOW);
          m_combotitle.ShowWindow(SW_SHOW);
          m_combochapter.ShowWindow(SW_SHOW);
          m_comboverse.ShowWindow(SW_SHOW);
		  m_staticbook.ShowWindow(SW_SHOW);
		  m_statictitle.ShowWindow(SW_SHOW);
		  m_staticchapter.ShowWindow(SW_SHOW);
		  m_staticverse.ShowWindow(SW_SHOW);

		  m_searchlist.ShowWindow(SW_HIDE);
		  m_edwordcontrol.ShowWindow(SW_HIDE);
		  m_display.ShowWindow(SW_HIDE);
		  m_statictype.ShowWindow(SW_HIDE);
		  m_staticfoundcontrol.ShowWindow(SW_HIDE);
//		  break;

//		}
//	}

//************************ Work with ComboBoxes **
	  	  //Recordset declaration
	      if (m_pRSW0)
		     if (m_pRSW0->IsOpen())
		      	m_pRSW0->Close();

	      delete m_pRSW0;

	      m_pRSW0 = new CDaoRecordset(m_pDB);
          m_pRSW0->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);  
		  
		  
		  //Clear the comboboxes
		  m_combobook.ResetContent();
		  m_combotitle.ResetContent();
		  m_combochapter.ResetContent();
          m_comboverse.ResetContent();
		  m_combobookrecno.ResetContent();
		  m_combotitlerecno.ResetContent();
		  m_combochapterrecno.ResetContent();
          m_comboverserecno.ResetContent();

         
		  //Move to 2nd record 
		  m_pRSW0->Move(2);

		 while (!m_pRSW0->IsEOF())
		 {
			 //Absolute position of record 
			 pos = m_pRSW0->GetAbsolutePosition();
			 ltoa(pos,chrrecno,10);

             //Values of Book, Title, Chapter and Verse fields
			 varbook1 = m_pRSW0->GetFieldValue(_T("Book"));         		
		     vartitle = m_pRSW0->GetFieldValue(_T("BookTitle"));         
             varchapter1 = m_pRSW0->GetFieldValue(_T("Chapter"));
             varverse1 = m_pRSW0->GetFieldValue(_T("Verse"));


			if (CString(V_BSTRT(&varbook1)) != m_book)  		  
			{
				if ((CString(V_BSTRT(&varchapter1)) == "001") && (CString(V_BSTRT(&varverse1)) == "001"))   		  
				{	
					//Add item to book and title comboboxes
					m_combobook.AddString(CString(V_BSTRT(&varbook1)));
					m_combotitle.AddString(CString(V_BSTRT(&vartitle)));

					//Add item to bookrecno and titlerecno comboboxes
					m_combobookrecno.AddString(CString(chrrecno));
					m_combotitlerecno.AddString(CString(chrrecno));		
				}
			}	
			else
			{
				if ((CString(V_BSTRT(&varchapter1)) == "001") && (CString(V_BSTRT(&varverse1)) == "001"))   		  
				{				
					//Add item to book and title comboboxes
					m_combobook.AddString(CString(V_BSTRT(&varbook1)));
					m_combotitle.AddString(CString(V_BSTRT(&vartitle)));

					//Add item to bookrecno and titlerecno comboboxes
					m_combobookrecno.AddString(CString(chrrecno));
					m_combotitlerecno.AddString(CString(chrrecno));	
				}
				if (CString(V_BSTRT(&varchapter1)) != m_chapter)
				{
					if (CString(V_BSTRT(&varverse1)) == "001") 
  			  
					{
						//Add item to chapter and chapterrecno comboboxes
						m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));	
						m_combochapterrecno.AddString(CString(chrrecno));
					}
				}
				else
				{
					if (CString(V_BSTRT(&varverse1)) == "001")   				  
						{
							//Add item to chapter and verse comboboxes
							m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));	
							m_comboverse.AddString(CString(V_BSTRT(&varverse1)));	
							
							//Add item to chapterrecno and verserecno comboboxes
							m_combochapterrecno.AddString(CString(chrrecno));
							m_comboverserecno.AddString(CString(chrrecno));								
					}	
					else
					{
							//Add item to verse and verserecno comboboxes
						    m_comboverse.AddString(CString(V_BSTRT(&varverse1)));								
							m_comboverserecno.AddString(CString(chrrecno));
					}
				}
			}

			m_pRSW0->MoveNext();
		 }
        
		 break;
		}
	}

   UpdateData(FALSE);

//Values display in the current strings of Comboboxes
	CString varcombo;
	int varcount = m_combobook.GetCount();
	for( int i = 0; i < varcount; ++i )
	{
       m_combobook.GetLBText(i,varcombo);
	   if (varcombo == m_book)
	   {
	      m_combobook.SetCurSel(i);
		  m_combotitle.SetCurSel(i);
	      goto Ptbook;
       }
	 }
    
Ptbook:
	 
	varcount = m_combochapter.GetCount();
	for( i = 0; i < varcount; ++i )
	{
       m_combochapter.GetLBText(i,varcombo);
	   if (varcombo == m_chapter)
	   {
	      m_combochapter.SetCurSel(i);
		  goto Ptchapter;
       }
	}
    
Ptchapter:
	varcount = m_comboverse.GetCount();
	for( i = 0; i < varcount; ++i )
	{
       m_comboverse.GetLBText(i,varcombo);
	   if (varcombo == m_verse)
	   {
	      m_comboverse.SetCurSel(i);
		  goto Ptverse;
       }
	 }
    
Ptverse:


	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CTestVC0Dlg::OnChangeEdword() 
{
	//Set the IDC_DISPLAY button enable
	m_display.EnableWindow(TRUE);
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnDisplay() 
{
	CString vrecordno, vtextdata, vbook, vtitle, vchapter, vverse;
	CString upperword,lowerword, leftword, rightword, ulword;
	long recordno;
	char chrrecno[40];
	int nNewItem, i, j;
	COleVariant var;

	//Recordset declaration
	if (m_pRSW0)
	if (m_pRSW0->IsOpen())
	m_pRSW0->Close();

	delete m_pRSW0;

	m_pRSW0 = new CDaoRecordset(m_pDB);
	m_pRSW0->Open(dbOpenDynaset, "SELECT * from BibleTable", 0); 

	//Set the IDC_DISPLAY button disable
	m_display.EnableWindow(FALSE);

	UpdateData(TRUE);

	//Clear the list control
	m_searchlist.DeleteAllItems();
	m_staticfound = "";

	//Uppercase style 
	upperword = m_edword;
	upperword.MakeUpper();

	//Lowercase  style
	lowerword = m_edword; 
	lowerword.MakeLower();
	
	//Uppercase + lowercase  style
	leftword = m_edword.Left(1);
	rightword = m_edword.Right(m_edword.GetLength() - 1); 
	leftword.MakeUpper();
	rightword.MakeLower();
	ulword = leftword + rightword;

	i = 0;
	m_pRSW0->Move(2);

	//Max items to found = 4999 
	while (!m_pRSW0->IsEOF() && i < 5000)
	{ 

	//Value of TextData field
	var = m_pRSW0->GetFieldValue(_T("TextData"));
	vtextdata = CString(V_BSTRT(&var));


	//Search condition 
	if ((vtextdata.Find(upperword) != -1) || (vtextdata.Find(lowerword) != -1) || (vtextdata.Find(ulword) != -1))

	{
	//Absolute position of record
	recordno = m_pRSW0->GetAbsolutePosition();

	//Convert long to string
	ltoa(recordno,chrrecno,10);
	vrecordno = CString(chrrecno);

	//Value of Book field
	var = m_pRSW0->GetFieldValue(_T("Book"));
	vbook = CString(V_BSTRT(&var));

	//Value of Title field
	var = m_pRSW0->GetFieldValue(_T("BookTitle"));
	vtitle = CString(V_BSTRT(&var)); 

	//Value of Chapter field
	var = m_pRSW0->GetFieldValue(_T("Chapter"));
	vchapter = CString(V_BSTRT(&var));

	//Value of Verse field
	var = m_pRSW0->GetFieldValue(_T("Verse"));
	vverse = CString(V_BSTRT(&var));

	//Insert item to List control
	nNewItem = m_searchlist.InsertItem(i,vrecordno,1);
	m_searchlist.SetItem(nNewItem,1,LVIF_TEXT,vbook,0,0,0,0);
	m_searchlist.SetItem(nNewItem,2,LVIF_TEXT,vtitle,0,0,0,0);
	m_searchlist.SetItem(nNewItem,3,LVIF_TEXT,vchapter,0,0,0,0);
	m_searchlist.SetItem(nNewItem,4,LVIF_TEXT,vverse,0,0,0,0);

	i = i + 1;
	j = i - 1;
	}
	m_pRSW0->MoveNext();

	}

	//Information about Items found	
	if (i < 1)
		m_staticfound = "0 item found.";
	else
	{
	itoa(j+1 ,chrrecno,10);
	if (j >= 4999)
	m_staticfound = "More then " + (CString)chrrecno + " items found."; 
	else
	m_staticfound = (CString)chrrecno + " items found."; 
	}

	UpdateData(FALSE);	
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnClickSearchlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString itemselected;
	long itemindex;
    COleVariant var;

	//Recordset declaration
	if (m_pRS)
		if (m_pRS->IsOpen())
			m_pRS->Close();

	delete m_pRS;

	m_pRS = new CDaoRecordset(m_pDB);
    m_pRS->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);  
  
	//Value of item selected 
	itemselected = m_searchlist.GetItemText(m_searchlist.GetSelectionMark(),0) ;
    itemindex = atol(itemselected.GetBuffer(40));
	

    //Display the record corresponding to the item selected
	if (itemindex > 1)
    {
	   if (itemindex == 31103)
	   {
          m_pRS->MoveLast();
	      CalculValue();
	      SetButtons(FALSE);
       }
       else
       {
	      m_pRS->Move(itemindex);
          CalculValue();

		  if (itemindex == 2)
		     SetButtons(TRUE);
	      else
   	      SetButtonsAll(TRUE);
	   }
   }
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CTestVC0Dlg::OnSelchangeComboBook() 
{
   CString varcombo;
   CString vcombbook1, vcombchapter1;
   long varrecno;
   
    //Record corresponding to the item selected of the book conbobox  
	m_pRS->MoveFirst();
    
    m_combobookrecno.SetCurSel(m_combobook.GetCurSel()); 
    m_combobookrecno.GetLBText(m_combobookrecno.GetCurSel(),varcombo);
	varrecno = atol(varcombo.GetBuffer(80));
	m_pRS->Move(varrecno);
	CalculValue();
    SetSituation();
	
	//In the current string of the title combobox displays the title of the book  
	m_combotitle.SetCurSel(m_combobook.GetCurSel()); 

	//Recordset declaration
	if (m_pRSW0)
		if (m_pRSW0->IsOpen())
			m_pRSW0->Close();

	delete m_pRSW0;

	m_pRSW0 = new CDaoRecordset(m_pDB);
    m_pRSW0->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);  

	//Clear the coomboboxes
	m_combochapter.ResetContent();
	m_combochapterrecno.ResetContent();
	m_comboverse.ResetContent();
	m_comboverserecno.ResetContent();

    //Chapter combobox stores all chapters orders of the book
	//Verse combobox stores all verses orders of the 1st chapter
	m_combobook.GetLBText(m_combobook.GetCurSel(),vcombbook1);
 
    m_pRSW0->Move(varrecno);
	
    m_pRSW0->GetFieldValue(_T("Chapter"), varchapter0);
    m_pRSW0->GetFieldValue(_T("Verse"), varverse0); 

	while (!m_pRSW0->IsEOF())
	{
		m_pRSW0->GetFieldValue(_T("Book"), varbook0);
		m_pRSW0->GetFieldValue(_T("Chapter"), varchapter1);
        m_pRSW0->GetFieldValue(_T("Verse"), varverse1);

        pos = m_pRSW0->GetAbsolutePosition();
                  ltoa(pos,chrrecno,10); 
		
		if (CString(V_BSTRT(&varbook0)) == vcombbook1)
		{	
		   if (CString(V_BSTRT(&varchapter1)) == "001")
			{
       		   if (CString(V_BSTRT(&varverse1)) == "001") 
			   {
	              m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));
                  m_comboverse.AddString(CString(V_BSTRT(&varverse1)));
	    				  
	              m_combochapterrecno.AddString(CString(chrrecno));
		          m_comboverserecno.AddString(CString(chrrecno));	

			   }
	           else
			   {
                    m_comboverse.AddString(CString(V_BSTRT(&varverse1)));
	    	         
	                 m_comboverserecno.AddString(CString(chrrecno));	
		   	   
			   }
		   }
	       else
           {
			  //Unique chapters orders
              if (CString(V_BSTRT(&varchapter0)) != CString(V_BSTRT(&varchapter1)))
			  {
				  m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));                    
				  
	              m_combochapterrecno.AddString(CString(chrrecno));
				  varchapter0 = varchapter1;
			  }
		   }
		}  
        m_pRSW0->MoveNext();
	}
	
    //In the current string of the chapter coombobox displays the first chapter order of the book  
    //In the current string of the verse coombobox displays the first verse order of the 1st chapter
    m_combochapter.SetCurSel(0);
    m_comboverse.SetCurSel(0);

	UpdateData(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::SetSituation()
{
	CString vcombbook,vcombtitle; 
	CString vcombchapter,vcombverse;

	m_combobook.GetLBText(m_combobook.GetCurSel(),vcombbook);
	m_combotitle.GetLBText(m_combotitle.GetCurSel(),vcombtitle);
	m_combochapter.GetLBText(m_combochapter.GetCurSel(),vcombchapter);
	m_comboverse.GetLBText(m_comboverse.GetCurSel(),vcombverse);


	if (vcombbook == _T("01") && vcombchapter == _T("001") && vcombverse == _T("001"))
		SetButtons(TRUE);
	else
	{
	if (vcombbook == _T("66") && vcombchapter == _T("022") && vcombverse == _T("021")) 
		SetButtons(FALSE);
	else
		SetButtonsAll(TRUE);
	}
}
void CTestVC0Dlg::OnSelchangeComboTitle() 
{
   CString varcombo;
   CString vcombtitle1, vcombchapter1;
   long varrecno;
   
    //Record corresponding to the item selected of the title conbobox
	m_pRS->MoveFirst();    
    m_combotitlerecno.SetCurSel(m_combotitle.GetCurSel()); 
    m_combotitlerecno.GetLBText(m_combotitlerecno.GetCurSel(),varcombo);
	varrecno = atol(varcombo.GetBuffer(80));
	m_pRS->Move(varrecno);
	CalculValue();
    SetSituation();

    //In the current string of the book combobox displays the order of the book  
	m_combobook.SetCurSel(m_combotitle.GetCurSel());

	//Recordset declaration
	if (m_pRSW0)
		if (m_pRSW0->IsOpen())
			m_pRSW0->Close();

	delete m_pRSW0;

	m_pRSW0 = new CDaoRecordset(m_pDB);
    m_pRSW0->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);  

	//Clear the comboboxes
	m_combochapter.ResetContent();
	m_combochapterrecno.ResetContent();
	m_comboverse.ResetContent();
	m_comboverserecno.ResetContent();

	
    //Chapter combobox stores all chapters orders of the book
	//Verse combobox stores all verses orders of the 1st chapter
	m_combotitle.GetLBText(m_combobook.GetCurSel(),vcombtitle1);
    
    m_pRSW0->Move(varrecno);
	
	m_pRSW0->GetFieldValue(_T("BookTitle"), vartitle);
    m_pRSW0->GetFieldValue(_T("Chapter"), varchapter0);
    m_pRSW0->GetFieldValue(_T("Verse"), varverse0); 	
    
	while (!m_pRSW0->IsEOF())
	{
		m_pRSW0->GetFieldValue(_T("BookTitle"), vartitle);
	    m_pRSW0->GetFieldValue(_T("Chapter"), varchapter1);
        m_pRSW0->GetFieldValue(_T("Verse"), varverse1);

		pos = m_pRSW0->GetAbsolutePosition();
        ltoa(pos,chrrecno,10);
		
		if (CString(V_BSTRT(&vartitle)) == vcombtitle1)
		{	
		   if (CString(V_BSTRT(&varchapter1)) == "001")
			{
       		   if (CString(V_BSTRT(&varverse1)) == "001") 
			   {
	              m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));
                  m_comboverse.AddString(CString(V_BSTRT(&varverse1)));
	    
				  m_combochapterrecno.AddString(CString(chrrecno));
		          m_comboverserecno.AddString(CString(chrrecno));	
			   }
	           else
			   {
                     m_comboverse.AddString(CString(V_BSTRT(&varverse1))); 	        
	                 m_comboverserecno.AddString(CString(chrrecno));	
		   	 
			   }
		   }
	       else
           {
              if (CString(V_BSTRT(&varchapter0)) != CString(V_BSTRT(&varchapter1)))
			  {
				  m_combochapter.AddString(CString(V_BSTRT(&varchapter1)));
                    
				  m_combochapterrecno.AddString(CString(chrrecno));
				  varchapter0 = varchapter1;
			  }
		   }
		}  
        m_pRSW0->MoveNext();
	}

    //In the current string of the chapter coombobox displays the first chapter order of the book  
    //In the current string of the verse coombobox displays the first verse order of the 1st chapter
    m_combochapter.SetCurSel(0);
    m_comboverse.SetCurSel(0);

	UpdateData(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnSelchangeComboChapter() 
{
  CString varcombo;
   CString vcombbook1, vcombchapter1;
   long varrecno;
   
    //Record corresponding to the item selected of the chapter conbobox   
	m_pRS->MoveFirst();
    m_combochapterrecno.SetCurSel(m_combochapter.GetCurSel()); 
    m_combochapterrecno.GetLBText(m_combochapterrecno.GetCurSel(),varcombo);
	varrecno = atol(varcombo.GetBuffer(80));
	m_pRS->Move(varrecno);
	CalculValue();
    SetSituation();

	
	//Recordset declaration
	if (m_pRSW0)
		if (m_pRSW0->IsOpen())
			m_pRSW0->Close();

	delete m_pRSW0;

	m_pRSW0 = new CDaoRecordset(m_pDB);
    m_pRSW0->Open(dbOpenDynaset, "SELECT  * from BibleTable", 0);  

	//Clear these comboboxes
	m_comboverse.ResetContent();
	m_comboverserecno.ResetContent();
 
   	//Verse combobox stores all verses orders of this chapter
	m_combobook.GetLBText(m_combobook.GetCurSel(),vcombbook1);
	m_combochapter.GetLBText(m_combochapter.GetCurSel(),vcombchapter1);
 
	m_pRSW0->Move(varrecno);
 
    while (!m_pRSW0->IsEOF())
	{

		m_pRSW0->GetFieldValue(_T("Book"), varbook0);
		m_pRSW0->GetFieldValue(_T("Chapter"), varchapter0);

		pos = m_pRSW0->GetAbsolutePosition();
        ltoa(pos,chrrecno,10); 

		if ((CString(V_BSTRT(&varbook0)) == vcombbook1) && (CString(V_BSTRT(&varchapter0)) == vcombchapter1))
        {
		   m_pRSW0->GetFieldValue(_T("Verse"), varverse0);             		   
		   m_comboverse.AddString(CString(V_BSTRT(&varverse0)));
		
		   m_comboverserecno.AddString(CString(chrrecno));
    	}
		m_pRSW0->MoveNext();
	 }
	 
    //In the current string of the verse coombobox displays the first verse order of this chapter  
	m_comboverse.SetCurSel(0);

	UpdateData(FALSE);
	// TODO: Add your control notification handler code here
	
}

void CTestVC0Dlg::OnSelchangeComboVerse() 
{
	CString varcombo;
    long varrecno;

    //Record corresponding to the item selected of the verse conbobox
    
	m_pRS->MoveFirst();
	m_comboverserecno.SetCurSel(m_comboverse.GetCurSel());
	m_comboverserecno.GetLBText(m_comboverserecno.GetCurSel(),varcombo);
	varrecno = atol(varcombo.GetBuffer(40));
	m_pRS->Move(varrecno);
	CalculValue();
    SetSituation();
	// TODO: Add your control notification handler code here
	
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//Database and Recordset objects declaration	
    CDaoDatabase* m_pDBW;
	CDaoRecordset* m_pRSW;
	
	m_pDBW = new CDaoDatabase;
	m_pRSW = new CDaoRecordset(m_pDBW);

	TCHAR curdir[MAX_PATH];  //MAX_PATH - Maximum length of directory
	
    // Get Current Directory
    GetCurrentDirectory( MAX_PATH, curdir ); 

	//DataBase name, KJV.mdb at Current Directory
	m_pDBW->Open((CString)curdir + _T("\\KJV.mdb"));  

    m_pRSW->Open(dbOpenDynaset, "SELECT * from BibleTable", 0);   
			  
	//First record of KJV.mdb file stores information about this database
	m_pRSW->Move(0);
   
	m_edsource = CString(V_BSTRT(&(m_pRSW->GetFieldValue(_T("TextData")))));
	UpdateData(FALSE);
  
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CAboutDlg::OnCreated() 
{
	CBiography dlgBiog;
	dlgBiog.DoModal();
	// TODO: Add your control notification handler code here
	
}
